import pylab as pl

file_coord = 'data/coord_France_SAFRAN.txt'

lon_France = pl.loadtxt(file_coord, skiprows=1, usecols=(2,))
lat_France = pl.loadtxt(file_coord, skiprows=1, usecols=(3,))

# SAFRAN resolution is 8km
# LAT: 1deg = 111.11km
# LON: 1deg = 111.11km x cos(lat in degress)
dlat_France = (8./111.11)*pl.ones(lat_France.shape)
dlon_France =  8./(111.11*pl.cos(lat_France*pl.pi/180.))

Nperline = 100
f = open('LONLATVAL.nam','w')
f.write('&NAM_LONLATVAL   NPOINTS='+str(len(lat_France)))

f.write('\nXX=')
for i in range(len(lat_France)):
  if pl.mod(i,Nperline) == 0: f.write('\n')
  f.write('{:.4f},'.format(lon_France[i]))

f.write('\nXY=')
for i in range(len(lat_France)):
  if pl.mod(i,Nperline) == 0: f.write('\n')
  f.write('{:.4f},'.format(lat_France[i]))

f.write('\nXDX=')
for i in range(len(lat_France)):
  if pl.mod(i,Nperline) == 0: f.write('\n')
  f.write('{:.4f},'.format(dlon_France[i]))

f.write('\nXDY=')
for i in range(len(lat_France)):
  if pl.mod(i,Nperline) == 0: f.write('\n')
  f.write('{:.4f},'.format(dlat_France[i]))

f.write('\n/')
f.close()





