# ----------------------------------------------
# IMPORT PYTHON LIBRARIES
# ----------------------------------------------
import pandas as pd
import pylab as pl
import numpy as np
import os
#import matplotlib.dates as mdates
import locale

# ----------------------------------------------
# IMPORT DEVELOPED LIBRARIES
# ----------------------------------------------
from ldasModule import *
from ldasPost import *
import ldasMapSet


# ==============================================
# MAIN PROGRAM
# ==============================================

exp = 'ekf_SP_SSM_only'
analysis_period = ['2007-01-01', '2007-12-31']
assim_hour = 9
out_obs_dir  = '/cnrm/vegeo/albergelc/ldas_chain_python/LDAS_v1.0.2/EU_LDAS/observations/sfx-trip/'
out_mod_dir  = '/cnrm/vegeo/leroux/LDAS/LDAS_curr/output_model_analysis/Clement/ol_SP/' 
out_ana_dir  = '/cnrm/vegeo/leroux/LDAS/LDAS_curr/output_model_analysis/Clement/'+exp+'/' 
graphics_dir = '/cnrm/vegeo/leroux/LDAS/LDAS_curr/figures/Clement/'+exp+'/'
fig_dpi = 300
post_obs_from_pickle = True
post_mod_from_pickle = True
post_ana_from_pickle = True
mod_grid = {'res': 0.5, 'type': 'uniform', 'zone': [[-11.5, 75.5], [62.5, 25.0]]}
mod_pgd_path = '/cnrm/vegeo/albergelc/ldas_chain_python/LDAS_v1.0.2/EU_LDAS/sfx-trip/pgd_prep/'
patch_frac = getModelPatchFractions(mod_pgd_path)
mod_info = {'n_steps': 8, 'dir': '/cnrm/vegeo/albergelc/ldas_chain_python/LDAS_v1.0.2/EU_LDAS/results/ol_SP/' , 'format': 'netcdf'}
ana_info = {'n_steps': 8, 'dir': '/cnrm/vegeo/albergelc/ldas_chain_python/LDAS_v1.0.2/EU_LDAS/results/'+exp+'/', 'format': 'netcdf'}
extra_diagnostics = {'increments_assim':['ANAL_INCR1','ANAL_INCR2','ANAL_INCR3','ANAL_INCR4','ANAL_INCR5','ANAL_INCR6','ANAL_INCR7','ANAL_INCR8','ANAL_INCR9'],\
                     'increments_names':['LAI increments','WG1 increments','WG2 increments','WG3 increments','WG4 increments','WG5 increments','WG6 increments',\
                                         'WG7 increments','WG8 increments']}
map_set = ldasMapSet.mapSet(mod_grid, mod_pgd_path)
#
'''
## LAI ##
obs_names = ['LAI','SSM']
#list_time_windows = ['month','season']
list_time_windows = ['day'] # for zoom on 2003 and 2007
for obs in obs_names:
    data = readAllData(obs, analysis_period, assim_hour, patch_frac, \
                       out_obs_dir, out_mod_dir, out_ana_dir, \
                       post_obs_from_pickle, post_mod_from_pickle, post_ana_from_pickle, \
                        mod_info, ana_info, ['Model','Analysis','Obs'])
    for time_window in list_time_windows:
        data_tw = applyTimeWindow(data, time_window)
        data_tw['Analysis-Model'] = data_tw['Analysis']-data_tw['Model']
        data_tw['Analysis-Model'].values[np.where(data_tw['Analysis-Model'].values==0.)]=np.nan
        draw_series_vars(data_tw.mean(axis=2), time_window, obs, graphics_dir, fig_dpi)
'''
#
## INCREMENTS ##
incr = readAllIncr(extra_diagnostics['increments_assim'], analysis_period, assim_hour, patch_frac, out_ana_dir, post_ana_from_pickle, ana_info)
# 
'''
time_window = 'season'
incr_tw = applyTimeWindow(incr, time_window)
#
minim = pl.hstack((pl.array([-0.01]),pl.ones((incr_tw.shape[0]-1,))*-0.00005)) # -0.05 -0.0005
maxim = pl.hstack((pl.array([ 0.01]),pl.ones((incr_tw.shape[0]-1,))* 0.00005))
draw_map_incr(map_set, incr_tw, time_window, graphics_dir, fig_dpi, extra_diagnostics['increments_names'],minim,maxim)
draw_series_incr(incr_tw, time_window, graphics_dir, fig_dpi, extra_diagnostics['increments_names'], minim, maxim)
#
'''
minim = pl.hstack((pl.array([-1.]),pl.ones((incr.shape[0]-1,))*-0.1))
maxim = pl.hstack((pl.array([ 1.]),pl.ones((incr.shape[0]-1,))* 0.1))
draw_series_incr_min_max(incr, 'day', graphics_dir, fig_dpi, extra_diagnostics['increments_names'], minim, maxim)



