import pylab as pl
import myPyFunc as my
from matplotlib import pylab as plt
from tqdm import trange
from time import time

# Parameters
zone = [[-10,30],[40,0]]

mod_res = 1.
obs_res = 1./12

radius = mod_res

# Code

def _res2lonlat(res,zone,pix_center=0,cut_buffer=0):
    lon = pl.arange(zone[0][0]-cut_buffer+(1-pix_center)*res/2,zone[1][0]+cut_buffer,res)
    lat = pl.arange(zone[1][1]-cut_buffer+(1-pix_center)*res/2,zone[0][1]+cut_buffer,res)
    return lon,lat



mod_lon,mod_lat = _res2lonlat(mod_res,[[-180,90],[180,-90]])


obs_zone = pl.array(zone)
obs_lon,obs_lat = _res2lonlat(obs_res,obs_zone)


mod_ul_lon = mod_lon[0]+mod_res*pl.ceil((obs_lon[0]-mod_lon[0])/mod_res+1/2)
mod_lr_lat = mod_lat[0]+mod_res*pl.ceil((obs_lat[0]-mod_lat[0])/mod_res+1/2)
mod_lon_buf,mod_lat_buf = _res2lonlat(mod_res,[[mod_ul_lon,obs_lat[-1]+obs_res/2],[obs_lon[-1]+obs_res/2,mod_lr_lat]],pix_center=1)

Kmod = pl.arange(len(mod_lon)*len(mod_lat),dtype='uint32').reshape(len(mod_lat),len(mod_lon))
Kobs = pl.arange(len(obs_lon)*len(obs_lat),dtype='uint32').reshape(len(obs_lat),len(obs_lon))

LON,LAT = pl.meshgrid(mod_lon,mod_lat)
LON = LON.ravel()
LAT = LAT.ravel()
X,Y = pl.meshgrid(obs_lon,obs_lat)
X = X.ravel()
Y = Y.ravel()

t0 = time()
if True:
  a = mod_res/obs_res
  b = radius/obs_res
  c_lon = (mod_lon[0]-obs_lon[0])/obs_res
  c_lat = (mod_lat[0]-obs_lat[0])/obs_res
  Npnt = int((2*b+1)**2)
  LUT = -999*pl.ones((len(mod_lat),len(mod_lon),Npnt),dtype='int32')
  for i in range(len(mod_lon)):
    for j in range(len(mod_lat)):
      I = slice(max(min(int(pl.ceil(a*i-b+c_lon)),len(obs_lon)),0),\
                max(min(int(pl.floor(a*i+b+c_lon))+1,len(obs_lon)),0))
      J = slice(max(min(int(pl.ceil(a*j-b+c_lat)),len(obs_lat)),0),\
                max(min(int(pl.floor(a*j+b+c_lat))+1,len(obs_lat)),0))
      tmp = Kobs[J,I].ravel()
      LUT[j,i,:len(tmp)] = tmp
  LUT = LUT.reshape((len(mod_lon)*len(mod_lat),Npnt))
else:
  a = mod_res/obs_res
  b = radius/obs_res
  c_lon = (mod_lon[0]-obs_lon[0])/obs_res
  c_lat = (mod_lat[0]-obs_lat[0])/obs_res
  Npnt = int((2*b+1)**2)
  LUT = -999*pl.ones((len(LON),Npnt),dtype='int32')
  for k in trange(len(LON)):
    i,j = pl.mod(k,len(mod_lon)),k/len(mod_lon)
    I = slice(max(pl.ceil(a*i-b+c_lon),0),min(pl.floor(a*i+b+c_lon)+1,len(obs_lon)))
    J = slice(max(pl.ceil(a*j-b+c_lat),0),min(pl.floor(a*j+b+c_lat)+1,len(obs_lat)))
    tmp = Kobs[J,I].ravel()
    LUT[k,:len(tmp)] = tmp
t0 = time()-t0
print('Elapsed time: {:0.4f}'.format(t0))



# Test figure

i = 196
j = 90
lut = LUT[Kmod[j,i],:]
if pl.any(lut == -999): lut = lut[:pl.argmax(lut==-999)]
plt.figure(1)
plt.clf()
plt.plot(mod_lon[i],mod_lat[j],'bo')
plt.plot(X[lut],Y[lut],'rx')
r = [mod_lon[i]-radius,mod_lon[i]+radius,mod_lat[j]-radius,mod_lat[j]+radius]
z = [zone[0][0],zone[1][0],zone[1][1],zone[0][1]]
o = [obs_zone[0][0],obs_zone[1][0],obs_zone[1][1],obs_zone[0][1]]
plt.plot([r[0],r[1],r[1],r[0],r[0]],[r[2],r[2],r[3],r[3],r[2]],'g')
plt.plot([z[0],z[1],z[1],z[0],z[0]],[z[2],z[2],z[3],z[3],z[2]],'y--')
plt.plot([o[0],o[1],o[1],o[0],o[0]],[o[2],o[2],o[3],o[3],o[2]],'y')
plt.axis('equal')
#plt.axis((mod_lon[i]-radius,mod_lon[i]+radius,mod_lat[j]-radius,mod_lat[j]+radius))

#k = 1000
#lut = LUT[k,:]
#if pl.any(lut == -999): lut = lut[:pl.argmax(lut==-999)]
#plt.figure(1)
#plt.clf()
#plt.plot(LON[k],LAT[k],'bo')
#plt.plot(X[lut],Y[lut],'rx')
#plt.axis((LON[k]-radius,LON[k]+radius,LAT[k]-radius,LAT[k]+radius))
