import numpy as np
from ldasModule import *
from ldasPre import getObsGrid,getAssimDates,readObs,getLookups,projectObs2ModGrid
F90_DIR = os.path.dirname(os.path.realpath(__file__))+'/F2Py/'
apply_lookup = load_dynamic('apply_lookup',F90_DIR+'apply_lookup.so').apply_lookup




def applyLookups(lut,data,min_num_obs):
    new_data = FILL+np.zeros((lut.shape[0],))
    for i in range(lut.shape[0]):
        tmp = data[lut[i,lut[i,:]>=0]]
        tmp = tmp[tmp!=FILL]
        new_data[i] = np.mean(tmp) if len(tmp)>=min_num_obs else FILL
    return new_data






# ==========================================
#
#                 MAIN
#
# ==========================================

# Options
#zone = [[-5,51],[8,42]]
zone = [[-180,90],[180,-90]]
sfx_grid = {'type': 'uniform', 'res': 1.0 , 'zone': zone}
trp_grid = {'type': 'uniform', 'res': 0.5 , 'zone': zone}

obs_names,obs_datasets = ['SSM'],['ESACCI']
obs_grids = ['def']
grid_transform_methods,grid_transform_parameters = ['def'],['def']
obs_root_dir = '/cnrm/vegeo/LDAS/OBSERVATIONS/'
#mod_pgd_path = '/home/muniers/LDAS/GLO_1D/France/pgd_prep/'
mod_pgd_path = '/home/muniers/LDAS/GLO_1D/sfx-trip/pgd_prep/'

analysis_period = ['2009-01-01', '2009-01-02']
assim_hour = 9

grid_transf_info_all = parseGridTransformInfo(obs_names,obs_grids,\
    grid_transform_methods,grid_transform_parameters,obs_root_dir,obs_datasets,sfx_grid)

v,obs_var = 0,'SSM'
obs_lon,obs_lat,obs_slices = getObsGrid(grid_transf_info_all[obs_var],zone)
obs_shape = (len(obs_lat),len(obs_lon))
assim_dates, obs_files = getAssimDates(analysis_period,assim_hour,obs_root_dir,obs_datasets[v],obs_var)
obs_daily = readObs(obs_files[0],obs_datasets[v],obs_var,obs_slices,obs_shape)

mod_lookup, empty_val = getLookups(sfx_grid,obs_grids[v],obs_lon,obs_lat,grid_transf_info_all[obs_var],mod_pgd_path)

obs_err = FILL+0*obs_daily
obs_proj_ref, _, _, _ = projectObs2ModGrid(mod_lookup,obs_daily,obs_err,grid_transf_info_all[obs_var])
obs_proj_ref[obs_proj_ref==FILL] = np.nan

obs_proj = apply_lookup(mod_lookup,obs_daily,grid_transf_info_all['SSM']['parameters']['min_obs'])
obs_proj[obs_proj==FILL] = np.nan
