from ldasPre import *
from obsFunctions import *
from ldasPre import _res2lonlat
from obsFunctions import _checkFlagBitsRescale
import myPyFunc as my
from matplotlib import pyplot as plt
from sys import exit

#zone = [[-180,90],[180,-90]] # Globe
#zone = [[10, 55], [30, 40]]
#zone = [[-10,50],[30,35]]
#zone = [[-65,10],[-45,-10]]
zone = [[-10,44],[5,35.5]] # Spain
#zone = [[-9.5,41.5],[-7.5,39.5]]

# OPTIONS from my_options
mod_grid = {'type': 'uniform', 'res': 0.25, 'zone': zone}
obs_names = ['SSM']
obs_datasets = ['ESACCI']
obs_grids = ['def']
grid_transform_methods = ['def']
grid_transform_parameters = ['def']
obs_root_dir = '/cnrm/vegeo/LDAS/OBSERVATIONS/'

exp_name = 'E2O_Spain' # Name of experiment
analysis_period = ['2009-01-01', '2009-12-31'] # Analysis period.
assim_hour = 9 # Assimilation hour (in range(24)).
mod_out_format = 'netcdf' # Model output file format.
mod_out_dtype = '>f4' # Model output data type (e.g. >f4 = big-endian 4-byte float).
mod_out_nsteps = 8 # Number of model output time steps in 1 day (should it be read from XTSTEP_OUTPUT in OPTIONS.nam?).
mod_out_npatches = 12 # Number of patches per model grid point (should it be read from NPATCH in ~/SVN/trunk/MY_RUN/SIMUTEST/OPTIONS.nam?).
mod_out_miss = 1e20 # Value for missing data in model output.
surf_screen_features = [['urban_fraction', 'altitude']] # Surface features used to screen observations (1 list per variable).
surf_screen_thresholds = [[.15, 1500]] # Thresholds of surface features (listed in surf_screen_features) for discarding observations.
screen_mod_names = [['WGI2']] # Model output variables used to screen observations (1 list per variable; the empty list [] means no screening).
screen_mod_steps = [[0]] # Time steps (in range(mod_out_nsteps)) of model output used for screening.
screen_mod_thres = [[0]] # Thresholds of model output variables (listed in screen_mod_names) for discarding observations.
rescale_methods = ['cdf_matching'] # Methods for re-scaling observations using model output (None means no re-scaling).
rescale_mod_names = ['WG2'] # Model output variables used for re-scaling observations.
rescale_mod_steps = [0] # Time steps (in range(mod_out_nsteps)) of model output used for re-scaling.
rescale_max_miss = [.9] # Maximum fraction of missing observations for re-scaling a grid-point time series; if not satisfied, observations are set to missing.
rescale_calibs = [True] # Booleans indicating whether the re-scaling parameters should be calibrated.
rescale_calib_periods = [['2009-01-01', '2009-12-31']] # Periods (start and end year, both included) over which the re-scaling parameters are calibrated.
openloop_dir = '/home/muniers/LDAS/Spain/results/ol/' # Folder from where openloop output is read in pre- and post-processing steps
analysis_dir = '/home/muniers/LDAS/Spain/results/ekf/' # Folder from where analysis output is read in post-processing step
mod_pgd_path = '/home/muniers/LDAS/Spain/sfx-trip/pgd_prep/'
out_files_dir = '/home/muniers/LDAS/Spain/observations/' # Folder where processed (CANARI files) observations are written
#mod_pgd_path = None

# OPTIONS for test
v = 0
obs_var = obs_names[v]
obs_dataset = obs_datasets[v]
curr_date = pd.datetime(2009,12,03)


# ldasPre script
openloop_out_info, _ = parseModelOutputInfo(mod_out_format,mod_out_dtype,mod_out_nsteps,mod_out_npatches,\
    mod_out_miss,openloop_dir,analysis_dir)
grid_transf_info_all = parseGridTransformInfo(obs_names,obs_grids,grid_transform_methods,grid_transform_parameters,\
    obs_root_dir,obs_datasets,mod_grid)
surface_info_all = parseSurfaceInfo(obs_names,surf_screen_features,surf_screen_thresholds,mod_pgd_path)
screen_mod_info_all = parseModOutScreenInfo(obs_names,screen_mod_names,screen_mod_thres,screen_mod_steps)
rescale_info_all = parseRescaleInfo(obs_names,rescale_methods,rescale_calibs,rescale_calib_periods,analysis_period,\
    rescale_mod_names,rescale_mod_steps,rescale_max_miss,exp_name,out_files_dir)
mod_patch_frac = getModelPatchFractions(mod_pgd_path)
obs_lon,obs_lat,obs_slices = getObsGrid(mod_grid,grid_transf_info_all[obs_var])
mod_lookup, empty_val = getLookups(mod_grid,obs_grids[v],obs_lon,obs_lat,grid_transf_info_all[obs_var],mod_pgd_path)
obs_shape = (len(obs_lat),len(obs_lon))
obs_daily = readObs(curr_date,obs_root_dir,obs_datasets[v],obs_var,obs_slices,obs_shape)
obs_err = FILL+0*obs_daily
obs_daily_proj, _, _, _ = projectObs2ModGrid(mod_lookup,obs_daily,obs_err,grid_transf_info_all[obs_var])

screen_mod_info = screen_mod_info_all[obs_var]
obs_daily_screen = modOutScreen(curr_date,obs_daily_proj,mod_patch_frac,openloop_out_info,screen_mod_info)
mod_values_screen = readModOutDaily(screen_mod_info['mod_out'][0],curr_date,screen_mod_info['steps'][0],mod_patch_frac,openloop_out_info,pl.nan)

assim_dates = pl.array([pd.Timestamp(curr_date.strftime('%Y%m%d'))])
obs_values = pd.DataFrame(pl.empty((assim_dates.size,mod_lookup.shape[0])),assim_dates)
obs_values.ix[curr_date] = obs_daily_screen
obs_values = surfaceScreen(obs_values,surface_info_all[obs_var])

obs_daily_screen = obs_values.ix[curr_date]


# check
mod_lon,mod_lat = _res2lonlat(mod_grid['res'],mod_grid['zone'])

obs = my.mdata(obs_lon,obs_lat[::-1],obs_daily.reshape((len(obs_lat),len(obs_lon)))[::-1,:])
obs_screen = my.mdata(mod_lon,mod_lat[::-1],obs_daily_screen.reshape((len(mod_lat),len(mod_lon)))[::-1,:])
mod = my.mdata(mod_lon,mod_lat[::-1],mod_values_screen.reshape((len(mod_lat),len(mod_lon)))[::-1,:])

vlim = [0,0.5]
#zone_graph = [[r['ul_lon'],r['ul_lat']],[r['lr_lon'],r['lr_lat']]]
zone_graph = zone
plt.figure(1); plt.clf()
obs.pmap(zone=zone_graph,MV=FILL,vmin=vlim[0],vmax=vlim[1]);
plt.figure(2); plt.clf()
obs_screen.pmap(zone=zone_graph,MV=FILL,vmin=vlim[0],vmax=vlim[1])
plt.figure(3); plt.clf()
mod.pmap(zone=zone_graph,MV=FILL,vmin=vlim[0],vmax=vlim[1])
my.link_axes()
plt.axis([zone_graph[0][0],zone_graph[1][0],zone_graph[1][1],zone_graph[0][1]])

