from ldasPre import *
from obsFunctions import *
from ldasPre import _res2lonlat
from obsFunctions import _checkFlagBitsRescale
import myPyFunc as my
from matplotlib import pyplot as plt
from sys import exit

#zone = [[-180,90],[180,-90]] # Globe
#zone = [[10, 55], [30, 40]]
#zone = [[-10,50],[30,35]]
#zone = [[-65,10],[-45,-10]]
zone = [[-10,44],[5,35.5]] # Spain
#zone = [[-9.5,41.5],[-7.5,39.5]]
#zone = [[-15,60],[50,20]] # Med

# OPTIONS from my_options
mod_grid = {'type': 'uniform', 'res': 1, 'zone': zone}
obs_names = ['FCOVER']
obs_datasets = ['BIOPAR']
obs_grids = ['def']
grid_transform_methods = ['def']
grid_transform_parameters = ['def']
obs_root_dir = '/cnrm/vegeo/LDAS/OBSERVATIONS/'
#mod_pgd_path = '/home/muniers/LDAS/Spain/sfx-trip/pgd_prep/'
mod_pgd_path = None

# OPTIONS for test
v = 0
obs_var = obs_names[v]
obs_dataset = obs_datasets[v]
curr_date = pd.datetime(2009,06,03)


# ldasPre script
grid_transf_info_all = parseGridTransformInfo(obs_names,obs_grids,grid_transform_methods,grid_transform_parameters,\
    obs_root_dir,obs_datasets,mod_grid)
obs_lon,obs_lat,obs_slices = getObsGrid(mod_grid,grid_transf_info_all[obs_var])
mod_lookup, empty_val = getLookups(mod_grid,obs_grids[v],obs_lon,obs_lat,grid_transf_info_all[obs_var],mod_pgd_path)
obs_shape = (len(obs_lat),len(obs_lon))
obs_daily = readObs(curr_date,obs_root_dir,obs_datasets[v],obs_var,obs_slices,obs_shape)
obs_err = FILL+0*obs_daily
obs_daily_proj, _, _, _ = projectObs2ModGrid(mod_lookup,obs_daily,obs_err,grid_transf_info_all[obs_var])


# check
region = 'EURO'
regions_file = '{0}{1}/{2}/{1}_{2}_REGIONS.csv'.format(obs_root_dir,obs_datasets[v],obs_var)
regions = pd.read_csv(regions_file,sep=',',header=0,index_col=0).T
r = regions[region]
file_name = getFileName(obs_root_dir,obs_datasets[v],obs_var,region,curr_date)
var_flag = readFromFile(file_name,VARS[obs_dataset][obs_var],row_invert=r['lat_invert'])
x,y = _res2lonlat(obs_grids[v]['res'],[[r['ul_lon'],r['ul_lat']],[r['lr_lon'],r['lr_lat']]],pix_center=r['pix_center'])
i0 = pl.argmax(x>=max(zone[0][0],x[0])); i1 = pl.argmax(x>=min(zone[1][0],x[-1]))+1
j0 = pl.argmax(y>=max(zone[1][1],y[0])); j1 = pl.argmax(y>=min(zone[0][1],y[-1]))+1
x,y = x[i0:i1],y[j0:j1]
for i in range(len(var_flag)): var_flag[i] = var_flag[i][j0:j1,i0:i1]

flag_values = [pl.zeros((len(y),len(x)))]
if obs_var == 'LAI':
  var = var_flag[0]/(30.*30.)
  flag = var_flag[1].astype('uint')
  Iflag = [1]+range(5,16)
  for i in Iflag:
    flag_values.append(1*(flag&(1<<i)!=0))
    flag_values[0] = pl.logical_or(flag_values[0],flag_values[-1])
  Iflag = [999]+Iflag
elif obs_var == 'SWI':
  var = var_flag[0]/(100.)
  Iflag = [999,1,2]
  flag_values.append(1*(var_flag[1]<80))
  flag_values.append(1*(var_flag[2]>=2))
  flag_values[0] = pl.logical_or(flag_values[0],flag_values[1]+flag_values[2])
elif obs_var == 'SSM':
  var = var_flag[0]
elif obs_var == 'FAPAR':
  var = var_flag[0]/(100*250.)
  flag = var_flag[1].astype('uint')
  Iflag = [0,1,5,7]
  for i in Iflag:
    flag_values.append(1*(flag&(1<<i)!=0))
    flag_values[0] = pl.logical_or(flag_values[0],flag_values[-1])
elif obs_var == 'SA':
  var = var_flag[0]/(1e4*1e4)
  var[var_flag[0]==999] = pl.nan
  flag = var_flag[1].astype('uint')
  Iflag = [0,2,5,6]
  for i in Iflag:
    flag_values.append(1*(flag&(1<<i)!=0))
    flag_values[0] = pl.logical_or(flag_values[0],flag_values[-1])
elif obs_var == 'LST':
  var = var_flag[0]
  var = var/(100*100)+273.15
  var[var==273.15-80] = FILL
  var[not var_flag[1] in pl.arange(4,8)] = FILL
elif obs_var == 'FCOVER':
  var = var_flag[0]/(250*250)
  flag = var_flag[1].astype('uint')
  Iflag = [0,1,5,6,7]
  for i in Iflag:
    flag_values.append(1*(flag&(1<<i)!=0))
    flag_values[0] = pl.logical_or(flag_values[0],flag_values[-1])


###
#var[var==999./(30*30)] = FILL
###

mod_lon,mod_lat = _res2lonlat(mod_grid['res'],mod_grid['zone'])

var = my.mdata(x,y[::-1],var[::-1,:])
obs = my.mdata(obs_lon,obs_lat[::-1],obs_daily.reshape((len(obs_lat),len(obs_lon)))[::-1,:])
obs_proj = my.mdata(mod_lon,mod_lat[::-1],obs_daily_proj.reshape((len(mod_lat),len(mod_lon)))[::-1,:])

dat_str = curr_date.strftime('%Y-%m-%d')
vlim = [0,1]
#zone_graph = [[r['ul_lon'],r['ul_lat']],[r['lr_lon'],r['lr_lat']]]
zone_graph = zone
plt.figure(1); plt.clf()
my.pmap([zone_graph[0][0]-1,zone_graph[1][0]+1],[zone_graph[1][1]-1,zone_graph[0][1]+1],pl.zeros((2,2)),MV=0)
var.pmap(zone=zone_graph,MV=FILL,vmin=vlim[0],vmax=vlim[1]);
plt.title('Original '+obs_var+' from '+obs_dataset+' over '+region+' - '+dat_str)
plt.figure(2); plt.clf()
obs.pmap(zone=zone_graph,MV=FILL,vmin=vlim[0],vmax=vlim[1])
plt.title('Combined '+obs_var+' from '+obs_dataset+' - '+dat_str)
plt.figure(3); plt.clf()
my.pmap([zone_graph[0][0]-1,zone_graph[1][0]+1],[zone_graph[1][1]-1,zone_graph[0][1]+1],pl.zeros((2,2)),MV=0)
obs_proj.pmap(zone=zone_graph,MV=FILL,vmin=vlim[0],vmax=vlim[1])
plt.title('Resampled '+obs_var+' on model grid - '+dat_str)
#for i in range(len(Iflag)):
  #plt.figure(10+i); plt.clf()
  #my.mdata(x,y[::-1],flag_values[i][::-1,:]).pmap(zone=zone_graph)
  #plt.title(Iflag[i])
my.link_axes()
plt.axis([zone_graph[0][0],zone_graph[1][0],zone_graph[1][1],zone_graph[0][1]])

